#include <windows.h>
#include <stdio.h>
#include <stdbool.h>
#include <string.h>
#include <shellapi.h>
#include <math.h>


SHELLEXECUTEINFOA processInfo;
HANDLE usbAssistentProcess;

int SelectComPort() //added function to find the present serial 
{
	char lpTargetPath[5000]; // buffer to store the path of the COM PORTS
    int portsList[256];
    int count = 0;

   // char str[1024];
    
    for (int i = 0; i < 255; i++) // checking ports from COM0 to COM255
    {
		char str[1024];
        sprintf(str, "COM%d", i);
        str[strlen(str)] = '\0';
        //printf("Com port %s\n", str);
        DWORD res = QueryDosDevice(str, lpTargetPath, 5000);

        // Test the return value and error if any
        if (res != 0) //QueryDosDevice returns zero if it didn't find an object
        {
			//printf("%d\n", i);
            portsList[count] = i;
            count++;
        }
        //memset(&str, 0, sizeof(str));
    }
    return portsList[count - 1];
}

int main()
{
	HANDLE port;
	char fileName[256];
	//-mwindow
	
	printf("USB-Assistent-Win64  v0.1\n");
	printf("(c) Copyright 2022 globment.de. All rights reserved.\n\n");
	
	printf("[Debug] Selected port %d\n", SelectComPort());


	sprintf(fileName, "\\\\.\\COM%d", SelectComPort());
	fileName[strlen(fileName)] = '\0';
	printf("[Debug] Filename : %s\n", fileName);
	port = CreateFileA(fileName,   //port name
	GENERIC_READ | GENERIC_WRITE, //Read/Write
	0,                            // No Sharing
	NULL,                         // No Security
	OPEN_EXISTING,// Open existing port only
	0,            // Non Overlapped I/O
	NULL);        // Null for Comm Devices

	if (port == INVALID_HANDLE_VALUE)
		printf("[Debug] Error in opening serial port\n");
	else
		printf("[Debug] opening serial port successful\n");

	COMMTIMEOUTS timeouts = {0};
	timeouts.ReadIntervalTimeout = 0;
	timeouts.ReadTotalTimeoutConstant = 200;
	timeouts.ReadTotalTimeoutMultiplier = 0;
	timeouts.WriteTotalTimeoutConstant = 100;
	timeouts.WriteTotalTimeoutMultiplier = 0;

	bool success = SetCommTimeouts(port, &timeouts);
	if (!success)
	{
		printf("[Debug] Failed to set serial timeouts\n");
		CloseHandle(port);
		return -1;
	}

	// Set the baud rate and other options.
	DCB state = {0};
	state.DCBlength = sizeof(DCB);
	state.BaudRate = 9600;
	state.ByteSize = 8;
	state.Parity = NOPARITY;
	state.StopBits = ONESTOPBIT;
	success = SetCommState(port, &state);
	
	if (!success)
	{
		printf("[Debug] Failed to set serial settings\n");
		CloseHandle(port);
		return -1;
	}
	
	/*
	processInfo.lpVerb = "OPEN";
	processInfo.lpFile = "cmd";
	processInfo.lpParameters = "/c shutdown /l";
	processInfo.nShow = SW_SHOW;
	processInfo.hwnd = GetDesktopWindow();
	processInfo.hProcess = &usbAssistentProcess;
	
	*/
	DWORD received;
	char buffer;
	int size;
	int count = 0, outCount = 0;;
	bool set_logout = false;
	bool first_recognition = false;
	bool second_recognition = false;
	bool break_recognition = false;
	int startCount = 0;
	size = sizeof(buffer);
	

//###########  Prototype loop for 2 hand movment recognition
/*
	while(count < 51) {
		success = ReadFile(port, &buffer, size, &received, NULL);
		if(success) {
			//printf("[Debug]Read from serial port %c\n", buffer);
		} else {
			//printf("[Debug] Read from serial port failed");
		}
		
		if(first_recognition) {
			if(buffer == '1') {
				printf("[Debug] First recognition detected\n");
				if(outCount < 10 && break_recognition &&
						abs(startCount - outCount) < 5) {
					printf("[Debug] Second recognition detected\n");
					second_recognition = true;
					first_recognition = false;
					outCount = 0;
				} 
				startCount = 0;
			} else if(buffer == '2') {
				//if(outCount > 50) {
				//	outCount = 0;
				//	first_recognition = false;
				//}
				if(outCount >= 0 && outCount < 10) {
					break_recognition = true;
				}
				if(outCount < 10) {
					startCount++;
					outCount++;
				} else {
					first_recognition = false;
					outCount = 0;
				}
				
			}
		} else {
			if(buffer == '1') {
				first_recognition = true;
				
			} 
		}


		if(second_recognition) {
			ShellExecuteA(GetDesktopWindow(),"open","cmd","/c shutdown",NULL, SW_SHOW); //command for hand recognition		
			second_recognition = false;
			first_recognition = false;
			break;
		}

		
		*/
// ################		
		
		printf("[Debug] OutCount : %d - %d\n", outCount, startCount);
		
		
		
		if(set_logout) {
			count++;
			if(buffer == '2') {
				set_logout = false;
				count = 0;
			}
		} else {
			if(buffer == '1') {
				set_logout = true;
				count++;
			}
		}
		if(count > 50) {
			printf("Benutzer wird abgemeldet.");
			//system("shutdown /l");
			//HINSTANCE retVal = ShellExecute(NULL, "open", "cmd", "/c netsh winsock reset catalog > CUninstall.log", NULL, SW_NORMAL);
			ShellExecuteA(GetDesktopWindow(),"open","cmd","/c shutdown /l",NULL, SW_HIDE);
			break;
		}
		
	}


	
	CloseHandle(port);//Closing the Serial Port

	return 0;
}
